{************************************************}
{                                                }
{  MSXCAS                                        }
{  MSX to IBMPC/XT/AT etc file converter         }
{  KORVET PK8020/PK8010 version                  }
{                                                }
{  Version 2.3.1                                 }
{  Copyright (C) MarinovSoft 2009-2018           }
{                                                }
{  From Kuzbass (Siberia) with Love              }
{                                                }
{  http://marinovsoft.narod.ru                   }
{  mailto:super386@rambler.ru                    }
{                                                }
{************************************************}
Uses App, Objects, Views, Menus, Drivers, Stddlg,
  MSXConst, Msgbox, GrowView, AppWin, Service, Part3Msx, OptDlg, SysUtils, Waves;
Type
  TKorvetAPP = Object(TApplication)
    TheFile: FNameStr;
    RAWFile: FNameStr;
    TX1File: FNameStr;
    TX2File: FNameStr;
    CASFile: FNameStr;
    BASFile: FNameStr;
    InfoWindow  : PInfoWindow;
    Procedure OpenWindow;
    Procedure RAWRecode;
    Procedure TX1Decode;
    Procedure TX2Decode;
    Procedure CASDecode;
    Procedure BASDecode;
    Procedure SetOptions;
    Procedure MSXFileNew;
    Procedure DoAboutBox;
    Procedure InitMenuBar; Virtual;
    Procedure InitStatusLine;Virtual;
    Procedure HandleEvent(Var Event:TEvent);Virtual;
    Constructor Init;
    Function ReadByte(Var Txt1:PStream):Byte;
  protected
    _LoadAddr,_EndAddr,_StartAddr:Word;
    _WriteWav:Boolean;
  End;
Procedure TKorvetAPP.InitStatusLine;
Var R:TRect;
Begin
  GetExtent(R);
  R.A.Y:=R.B.Y-1;
  New(StatusLine,Init(R,
    NewStatusDef(0,$Ffff,
    NewStatusKey('~Alt-X~ Exit',kbAltX,cmQuit,
    NewStatusKey('~F3~ Open',kbF3,cmOpen,
    StdStatusKeys(Nil))),
    Nil)));
End;
Procedure TKorvetAPP.HandleEvent(Var Event:TEvent);
{Var
  Fn:FNameStr;}
Begin
  If Event.What=evCommand Then
  Begin
    Case Event.Command Of
      cmOpen:
      Begin
        OpenWindow;
        ClearEvent(Event);
      End;
      cmAbout:
      Begin
        DoAboutBox;
        ClearEvent(Event);
      End;
      cmClose:
      Begin
        InfoWindow := Nil;
        DisableCommands([cmRAWProcess,
                         cmTX1Process,
                         cmTX2Process,
                         cmCASProcess,
                         cmBASProcess]);
      End;
      cmRAWProcess:
      Begin
        RAWRecode;
        ClearEvent(Event);
      End;
      cmTX1Process:
      Begin
        TX1Decode;
        ClearEvent(Event);
      End;
      cmTX2Process:
      Begin
        TX2Decode;
        ClearEvent(Event);
      End;
      cmCASProcess:
      Begin
        CASDecode;
        ClearEvent(Event);
      End;
      cmBASProcess:
      Begin
        BASDecode;
        ClearEvent(Event);
      End;
      cmNew:
      Begin
        MSXFileNew;
        ClearEvent(Event);
      End;
      cmOptions:
      Begin
        setOptions;
        ClearEvent(event);
      End;
    End;
  End;
  Inherited HandleEvent(Event);
End;

Procedure TKorvetAPP.OpenWindow;
Var
{  R: TRect;}
  FileDialog: PFileDialog;
Const
  fdOptions: Word = fdOkButton + fdOpenButton;
Begin
  TheFile := '*.RAW';
  FileDialog := New(PFileDialog, Init(TheFile, 'Open file', '~F~ile name',
    fdOptions, 1));
  If ExecuteDialog(FileDialog, @TheFile) <> cmCancel Then
  Begin
    If InfoWindow <> Nil Then Dispose(InfoWindow, Done);
    InfoWindow := New(PInfoWindow , Init(TheFile));
    InsertWindow(InfoWindow);
    With InfoWindow^ Do
    Begin
      WriteLine('|31| Reading file '+TheFile);
    End;
    {    R.Assign(0, 0, 75, 20);
    InsertWindow(New(PEditWindow, Init(R, Thefile, 0)));}
    EnableCommands([cmRAWProcess,
                    cmTX1Process,
                    cmTX2Process,
                    cmCASProcess,
                    cmBASProcess]);
  End;
End;
Procedure TKorvetAPP.DoAboutBox;
Begin
  MessageBox(#3'MSX File Converter v2.3.1'#13 +
    #3'Copyright (C) 2007-2018'#13#3'ਭ ࣨ aka MarinovSoft',
    Nil, mfInformation Or mfOKButton);
End;
Procedure TKorvetAPP.InitMenuBar;
Var
  R: TRect;
Begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~F~ile', hcNoContext, NewMenu(
    NewItem('~N~ew', 'F2', kbF2, cmNew, hcNoContext,
    NewItem('~O~pen...', 'F3', kbF3, cmOpen,  hcNoContext,
    NewLine(
    NewItem('O~p~tions', '', kbNoKey, cmOptions, hcNoContext,
    NewLine(
    NewItem('E~x~it', 'Alt-X', kbAltX, cmQuit,  hcNoContext,
    Nil))))))),
    NewSubMenu('~D~ecode', hcNoContext, NewMenu(
    NewItem('~R~aw recode', '', kbNoKey, cmRAWProcess, hcNoContext,
    NewItem('Phase ~1~ decode', '', kbNoKey, cmTX1Process, hcNoContext,
    NewItem('Phase ~2~ decode', '', kbNoKey, cmTX2Process, hcNoContext,
    NewItem('~C~AS/TXT/BIN decode', '', kbNoKey, cmCASProcess, hcNoContext,
    NewItem('~B~AS decode', '', kbNoKey, cmBASProcess, hcNoContext,
    Nil)))))),
    NewSubMenu('~W~indow', hcNoContext, NewMenu(
    StdWindowMenuItems(Nil)),
    NewSubMenu('~H~elp', hcNoContext, NewMenu(
    NewItem('~A~bout...', 'F1', kbF1, cmAbout, hcNoContext,
    Nil)),
    Nil)))))));
End;

Procedure TKorvetAPP.RAWRecode;
Var
  D   : PProgressDialog;
  GV1 : PGrowView;
  _TheFile:PStream;
  _RAWFile:PStream;
  C:Array[$0..$Ff] Of SmallInt;
  {$IFNDEF VIRTUALPASCAL}
  Code:Word;
  {$ELSE}
  Code:LongInt;
  {$ENDIF}
  J:Word;
  Fz:LongInt;
Begin
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Open file '+TheFile+' for recode');
    RAWFile:=Service.ChangeFileExt(TheFile,'MSR');
    WriteLine('|31| Write to '+RAWFile);
  End;

  _TheFile:=New(PBufStream, Init(TheFile, stOpenRead, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TheFile);
    Dispose(_TheFile, Done);
    Exit;
  End;

  _RAWFile:=New(PBufStream, Init(RAWFile, stCreate, 20148));
  If _RAWFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + RAWFile);
    Dispose(_TheFile, Done);
    Dispose(_RAWFile, Done);
    Exit;
  End;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Recode RAW file');

  Fz:=_TheFile^.GetSize;
  Repeat
    Code:=$FF;
    If (Fz - _TheFile^.GetPos) < $FF Then
      Code:=Fz - _TheFile^.GetPos;

    _TheFile^.Read(C, Code);
    For J:=$00 To (Code Div 2)-1 Do
    Begin
      If (C[J]>0) Then C[J]:=5000;
      If (C[J]<0) Then C[J]:=-5000;
    End;
    _RAWFile^.Write(C, Code);
    GV1^.Update((100 * _TheFile^.GetPos) Div Fz);
  Until _TheFile^.GetPos = Fz;
  Dispose(D,Done);

  Dispose(_TheFile, Done);
  Dispose(_RAWFile, Done);

  With InfoWindow^ Do
  Begin
    InfoWindow^.WriteLine('|31| You can rename *.MSR file to *.RAW file for writing to cassette');
  End;
End;
Procedure TKorvetAPP.TX1Decode;
Var
  D   : PProgressDialog;
  GV1 : PGrowView;
  _RAWFile:PStream;
  _TX1File:PStream;
  Counter:Byte;
  W:SmallInt;
  Fz:LongInt;
Const
  Byte_1:Char = '1';
  Byte_0:Char = '0';
Begin
  With InfoWindow^ Do
  Begin
    RAWFile:=Service.ChangeFileExt(TheFile,'MSR');
    WriteLine('|31| Process phase 1 file '+RAWFile+' decode');
    TX1File:=Service.ChangeFileExt(TheFile,'TX1');
    WriteLine('|31| Set output file '+TX1File);
    WriteLine('|31| Please wait...It''s a very long operation');
  End;

  _RAWFile:=New(PBufStream, Init(RAWFile, stOpenRead, 2048));
  If _RAWFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + RAWFile);
    Dispose(_RAWFile, Done);
    Exit;
  End;

  _TX1File:=New(PBufStream, Init(TX1File, stCreate, 2048));
  If _TX1File^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + TX1File);
    Dispose(_RAWFile, Done);
    Dispose(_TX1File, Done);
    Exit;
  End;

  Counter:=0;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Phase 1 decode');

  Fz:=_RAWFile^.GetSize;
  Repeat
    _RAWFile^.Read(W, SizeOf(W));
    If W<0 Then
      Inc(Counter,1)
    Else
    Begin
      If (Counter>5) And (Counter<14) Then _TX1File^.Write(Byte_1, SizeOf(Byte_1));
      If (Counter>14) And (Counter<30) Then _TX1File^.Write(Byte_0, SizeOf(Byte_0));
      Counter:=0;
    End;
    GV1^.Update((100 * _RAWFile^.GetPos) Div Fz);
  Until _RAWFile^.GetPos = Fz;

  Dispose(_RAWFile, Done);
  Dispose(_TX1File, Done);

  Dispose(D,Done);
End;
Procedure TKorvetAPP.TX2Decode;
Var
  D   : PProgressDialog;
  GV1 : PGrowView;
  _TX1File:PStream;
  _TX2File:PStream;
  Fz:LongInt;
  CH:Byte;
  Is1:Boolean;
{  Is0:Boolean;}
Begin
  With InfoWindow^ Do
  Begin
    TX1File:=Service.ChangeFileExt(TheFile,'TX1');
    WriteLine('|31| Process phase 2 file '+TX1File);
    TX2File:=Service.ChangeFileExt(TheFile,'TX2');
    WriteLine('|31| Set output file '+TX2File);
    WriteLine('|31| Please wait...It''s a very long operation');
  End;

  _TX1File:=New(PBufStream, Init(TX1File, stOpenRead, 2048));
  If _TX1File^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TX1File);
    Dispose(_TX1File, Done);
    Exit;
  End;

  _TX2File:=New(PBufStream, Init(TX2File, stCreate, 2048));
  If _TX2File^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + TX2File);
    Dispose(_TX1File, Done);
    Dispose(_TX2File, Done);
    Exit;
  End;

  CH:=0;
{  Is0:=False;}
  Is1:=False;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Phase 2 decode');

  Fz:=_TX1File^.GetSize;
  Repeat
    _TX1File^.Read(CH, SizeOf(CH));

    GV1^.Update((100 * _TX1File^.GetPos) Div Fz);
    If CH=Byte('0') Then
    Begin
      _TX2File^.Write(CH, SizeOf(CH));
      Is1:=False;
      Continue;
    End;
    If Is1 Then
      Is1:=False
    Else
    Begin
      _TX2File^.Write(CH, SizeOf(CH));
      Is1:=True;
    End;
  Until _TX1File^.GetPos = Fz;
  Dispose(_TX1File, Done);
  Dispose(_TX2File, Done);

  Dispose(D,Done);
End;
Procedure TKorvetAPP.CASDecode;
Var
  D   : PProgressDialog;
  GV1 : PGrowView;
  _TX2File:PStream;
  _CASFile:PStream;
  CH:Byte;
  Fz:LongInt;
  F_Type:Array[1..10] Of Byte;
  J2:Byte;
{  S:String;}
  LoadAddr,EndAddr,StartAddr:Word;
  MSXFileExist:Boolean;
Begin
  With InfoWindow^ Do
  Begin
    TX2File:=Service.ChangeFileExt(TheFile,'TX2');
    WriteLine('|31| Open file '+TX2File+' for reading');
    CASFile:=Service.ChangeFileExt(TheFile,'CAS');
    WriteLine('|31| Process CAS file create');
  End;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Process CAS file create');

  _TX2File:=New(PBufStream, Init(TX2File, stOpenRead, 2048));
  If _TX2File^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TX2File);
    Dispose(_TX2File, Done);
    Exit;
  End;

  MSXFileExist:=False;
  Fz:=_TX2File^.GetSize;
  Repeat
    _TX2File^.Read(CH, Sizeof(CH));
    GV1^.Update((100 * _TX2File^.GetPos) Div Fz);
    If CH=Byte('0') Then
    Begin
      MSXFileExist:=True;
      Break;
    End;
  Until False or (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);

  If Not MSXFileExist Then
  Begin
    InfoWindow^.WriteLine('|31| File ' + TX2File + ' is not valid MSX file');
    Dispose(_TX2File, Done);
    Exit;
  End;

  MSXFileExist:=False;

  _TX2File^.Seek(_TX2File^.GetPos - 1);

  For CH:=1 To 10 Do
    F_Type[CH]:=ReadByte(_TX2File);
  For CH:=1 To 10 Do
    InfoWindow^.WriteLine('|31| Found FileType '+IntToStr(CH)+' '+IntToStr(F_Type[CH]));
  Case F_Type[10] Of
    $D3:
    Begin
      CASFile[0]:=#6;
      For CH:=1 To 6 Do
        CASFile[CH]:=Chr(ReadByte(_TX2File));
      InfoWindow^.WriteLine('|31| Found MSX Basic file '+CASFile);
      InfoWindow^.WriteLine('|31| You can rename it');
      CASFile:=Service.ChangeFileExt(TheFile,'CAS');
      InfoWindow^.WriteLine('|31| Processing CAS file create '+CASFile);
      Repeat
        _TX2File^.Read(CH, SizeOf(CH));
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        If CH=Byte('0') Then
        Begin
          MSXFileExist:=True;
          Break;
        End;
      Until False or (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);
      _TX2File^.Seek(_TX2File^.GetPos - 1);

      _CASFile:=New(PBufStream, Init(CASFile, stCreate, 2048));
      If _CASFile^.Status <> stOk Then
      Begin
        InfoWindow^.WriteLine('|31| Can''t create file ' + CASFile);
        Dispose(_TX2File, Done);
        Dispose(_CASFile, Done);
        Dispose(D,Done);
        Exit;
      End;

      Repeat
        CH:=ReadByte(_TX2File);
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        _CASFile^.Write(CH, SizeOf(CH));
      Until (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);
      InfoWindow^.WriteLine('|31| CAS file '+CASFile+' create successfully!!!');
      Dispose(_CASFile, Done);
    End;
    $Ea:
    Begin
      CASFile[0]:=#6;
      For CH:=1 To 6 Do
        CASFile[CH]:=Chr(ReadByte(_TX2File));
      InfoWindow^.WriteLine('|31| Found MSX Text file '+CASFile);
      InfoWindow^.WriteLine('|31| You can rename it');
      CASFile:=Service.ChangeFileExt(TheFile,'TXT');
      InfoWindow^.WriteLine('|31| Processing TXT file create '+CASFile);
      Repeat
        _TX2File^.Read(CH,SizeOf(CH));
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        If CH=Byte('0') Then
        Begin
          MSXFileExist:=True;
          Break;
        End;
      Until (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);

      _TX2File^.Seek(_TX2File^.GetPos - 1);

      _CASFile:=New(PBufStream, Init(CASFile, stCreate, 2048));
      If _CASFile^.Status <> stOk Then
      Begin
        InfoWindow^.WriteLine('|31| Can''t create file ' + CASFile);
        Dispose(_TX2File, Done);
        Dispose(_CASFile, Done);
        Dispose(D,Done);
        Exit;
      End;

      J2:=0;
{      S:='';}
      Repeat
        If J2=0 Then
        Begin
          Repeat
            _TX2File^.Read(CH, SizeOf(CH));
            GV1^.Update((100*_TX2File^.GetPos) Div Fz);
            If CH=Byte('0') Then Break;
          Until False or (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);
          _TX2File^.Seek(_TX2File^.GetPos - 1);
        End;

        CH:=ReadByte(_TX2File);
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        If CH=$1A Then Break;
        _CASFile^.Write(CH,SizeOf(CH));
        Inc(J2,1);
      Until (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);
      InfoWindow^.WriteLine('|31| TXT file '+CASFile+' create successfully!!!');
      Dispose(_CASFile, Done);
    End;
    $D0:
    begin
      CASFile[0]:=#6;
      For CH:=1 To 6 Do
        CASFile[CH]:=Chr(ReadByte(_TX2File));
      InfoWindow^.WriteLine('|31| Found MSX binary file '+CASFile);
      CASFile:=Service.ChangeFileExt(TheFile,'BIN');
      InfoWindow^.WriteLine('|31| Processing BIN file create '+CASFile);
      Repeat
        _TX2File^.Read(CH,SizeOf(CH));
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        If CH=Byte('0') Then Break;
      Until False or (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);

      _TX2File^.Seek(_TX2File^.GetPos - 1);

      LoadAddr:=Word(ReadByte(_TX2File))+Word(ReadByte(_TX2File))shl 8;
      InfoWindow^.WriteLine('|31| Load addres is '+ IntToHex(LoadAddr, 4)+ 'h');
      EndAddr:=Word(ReadByte(_TX2File))+ReadByte(_TX2File)shl 8;
      InfoWindow^.WriteLine('|31| End addres is '+ IntToHex(EndAddr, 4) + 'h');
      StartAddr:=Word(ReadByte(_TX2File))+ReadByte(_TX2File)shl 8;
      InfoWindow^.WriteLine('|31| End addres is '+IntToHex(StartAddr, 4) + 'h');

      _CASFile:=New(PBufStream, Init(CASFile, stCreate, 2048));
      If _CASFile^.Status <> stOk Then
      Begin
        InfoWindow^.WriteLine('|31| Can''t create file ' + CASFile);
        Dispose(_TX2File, Done);
        Dispose(_CASFile, Done);
        Dispose(D,Done);
        Exit;
      End;

      Repeat
        CH:=ReadByte(_TX2File);
        GV1^.Update((100*_TX2File^.GetPos) Div Fz);
        _CASFile^.Write(CH,SizeOf(CH));
      Until (_TX2File^.GetPos = Fz) or (_TX2File^.Status <> stOk);
      InfoWindow^.WriteLine('|31| BIN file '+CASFile+' create successfully!!!');
      Dispose(_CASFile, Done);
    end;
  End;
  Dispose(_TX2File, Done);
  Dispose(D,Done);
End;
Procedure TKorvetAPP.BASDecode;
Var
  D   : PProgressDialog;
  GV1 : PGrowView;
  _CASFile:PStream;
  _BASFile:PBasFile;
  Nor:Word;
  Fz:LongInt;
  LineNumber:Word;
  S:String;
Begin
  With InfoWindow^ Do
  Begin
    CASFile:=Service.ChangeFileExt(TheFile,'CAS');
    WriteLine('|31| Open file '+CASFile+' for reading');
    BASFile:=Service.ChangeFileExt(TheFile,'BAS');
    WriteLine('|31| Processing BAS file create '+BASFile);
  End;
  _CASFile:=New(PBufStream, Init(CasFile, stOpenRead, 2048));
  IF _CASFile^.Status <> stOk Then
  begin
    InfoWindow^.WriteLine('|31| Error reading file: '+CASFile);
    Dispose(_CasFile, Done);
    Exit;
  end;
  _BASFile:=New(PBASFile, Init(_CASFile,''));
  _BASFile^.WriteBASFile(BASFile);
  InfoWindow^.WriteLine('|31| BAS file '+BASFile+' create successfully!!!');
  Dispose(_BASFile, Done);
  Dispose(_CASFile, Done);
//  Dispose(D,Done);
End;

Function TKorvetAPP.ReadByte(Var Txt1:PStream):Byte;
Var
  B:Byte;
  J:Byte;
  Arr:Array[1..11] Of Byte;
Const
  Arr1:Array[1..8] Of Byte=($1,$2,$4,$8,$10,$20,$40,$80);
Begin
  B:=0;
  MSXError:=0;
  {$I-}
  Txt1^.Read(Arr, 11);
  {$I+}
  If Arr[1]<>Byte('0') Then MSXError:=MSXError1;
  If Arr[10]<>Byte('1') Then MSXError:=MSXError2;
  If Arr[11]<>Byte('1') Then MSXError:=MSXError2;
  For J:=2 To 9 Do
    If Arr[J]=Byte('1') Then
      B:=B Or Arr1[J-1];
  ReadByte:=B;
End;

Procedure TKorvetAPP.MSXFileNew;
Var
  _TheFile:PStream;
  _RAWFile:PStream;
  fz:LongInt;
  D   : PProgressDialog;
  GV1 : PGrowView;
Const
  Arr1:Array[1..8] Of Byte=($1,$2,$4,$8,$10,$20,$40,$80);
Const
  Bit1 : Array[1..36] Of Integer =
  (-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,
    5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000,
   -5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,
    5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000);
  Bit0 : Array[1..36] Of Integer =
  (-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,
   -5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,-5000,
    5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000,
    5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000, 5000);
  WaveHeader:TWaveHeader =
  (idRiff:'RIFF';RiffLen:0;idWave:'WAVE');
  FmtHeader:TFmtHeader =
  (idFmt:'fmt ';InfoLen:16;WaveType:1;Ch:1;Freq:44100;BytesPerSec:88200;Align:2;Bits:16);
  DataHeader:TDataHeader =
  (idData:'data';DataLen:0);
Var
  DataLen:LongInt;
Procedure Write_bit_1;
begin
   _RAWFile^.Write(Bit1,SizeOf(Bit1));
   Inc(DataLen, SizeOf(Bit1));
end;
Procedure Write_bit_0;
begin
   _RAWFile^.Write(Bit0,SizeOf(Bit0));
   Inc(DataLen, SizeOf(Bit0));
end;
Procedure Write_Byte(B:Byte);
Var
  I:Byte;
Begin
  Write_bit_0;
  For I:=1 To 8 Do
    If (B And Arr1[I])=Arr1[I] Then
      Write_bit_1
    Else
      Write_bit_0;
  Write_bit_1;
  Write_bit_1;
End;
Procedure WriteFileName(S:String);
Var
  i:Byte;
begin
  For I:=1 to 6 Do
      Write_Byte(Byte(S[I]));
end;
procedure WriteWaveHeader;
begin
  _RAWFile^.Seek(0);
  DataHeader.DataLen:=DataLen;
  WaveHeader.RiffLen:=DataLen + SizeOf(WaveHeader.idWave) + SizeOf(FmtHeader) + SizeOf(DataHeader);
  _RAWFile^.Write(WaveHeader,SizeOf(WaveHeader));
  _RAWFile^.Write(FmtHeader,SizeOf(FmtHeader));
  _RAWFile^.Write(DataHeader,SizeOf(DataHeader));
end;
Procedure Txt2Msx(TheFile:String; WriteWav:Boolean);
Var
   B:Byte;
   W:Word;
   j:Byte;
Const
   nul0:Integer=0;
Begin
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Reading file '+TheFile);
    If WriteWav Then
      RAWFile:=Service.ChangeFileExt(TheFile,'WAV')
    Else
      RAWFile:=Service.ChangeFileExt(TheFile,'RAW');
    WriteLine('|31| Convert source to MSX tape textfile '+RAWFile);
    WriteLine('|31| Open this file in your Wave Editor or Player with following params:');
    WriteLine('|31| Sample rate: 44100 Hz');
    WriteLine('|31| Sample type: 16 Bit PCM');
    WriteLine('|31| Signed');
    WriteLine('|31| Byte order: Little-endian');
    WriteLine('|31| Chanels: Mono');
    WriteLine('|31| Set MSX filename to ['+GetMSXFileName(RAWFile)+']');
    WriteLine('|31| In PK8020/PK8010 KORVET you can read this file:');
    WriteLine('|31| LOAD "CAS:'+GetMSXFileName(RAWFile)+'",A');
  End;

  _TheFile:=New(PBufStream, Init(TheFile, stOpenRead, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TheFile);
    Dispose(_TheFile, Done);
    Exit;
  End;

  Fz:=_TheFile^.GetSize;
  If Fz = 0 Then
  Begin
    InfoWindow^.WriteLine('|31| File: '+TheFile+' is empty');
    Dispose(_TheFile, Done);
    Exit;
  end;

  _RAWFile:=New(PBufStream, Init(RAWFile, stCreate, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + RAWFile);
    Dispose(_RAWFile, Done);
    Dispose(_TheFile, Done);
    Exit;
  End;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Convert textfile');

  DataLen:=0;
  If WriteWav Then
    _RawFile^.Seek(SizeOf(TWaveHeader) + SizeOf(TFmtHeader) + SizeOf(TDataHeader));

  For W:=1 to $1E00 do Write_bit_1;
  For W:=1 to 10 Do Write_Byte($EA);
  WriteFileName(GetMSXFileName(RAWFile));
  j:=0;
  repeat
    if j=0 then
      begin
        For W:=1 to $FFFF do
           _RAWFile^.Write(Nul0,SizeOf(Nul0));
        DataLen:=DataLen + $FFFF * SizeOf(Nul0);
        For W:=1 to $780 do Write_bit_1;
      end;
    _TheFile^.Read(B,SizeOf(B));
    Write_Byte(B);
    GV1^.Update((100*_TheFile^.GetPos) Div Fz);
    inc(j);
  until (_TheFile^.GetPos = Fz) or (_TheFile^.Status <> stOk);
  if j<>0 then
    for b:=j to 255 do
      Write_Byte($1A);
  Write_Byte($1A);
  If WriteWav Then
    WriteWaveHeader;
  Dispose(_TheFile, Done);
  Dispose(_RAWFile, Done);
  Dispose(D,Done);
  With InfoWindow^ Do
  Begin
    InfoWindow^.WriteLine('|31| Sucessfully!!!');
  End;
End;

Procedure Cas2Msx(TheFile:String; WriteWav:Boolean);
Var
   B:Byte;
   W:Word;
{   j:Byte;}
   _FilePos:LongInt;
Const
   nul0:Integer=0;
begin
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Reading file '+TheFile);
    If WriteWav Then
      RAWFile:=Service.ChangeFileExt(TheFile,'WAV')
    Else
      RAWFile:=Service.ChangeFileExt(TheFile,'RAW');
    WriteLine('|31| Convert source to MSX tape BASIC file '+RAWFile);
    WriteLine('|31| Open this file in your Wave Editor or Player with following params:');
    WriteLine('|31| Sample rate: 44100 Hz');
    WriteLine('|31| Sample type: 16 Bit PCM');
    WriteLine('|31| Signed');
    WriteLine('|31| Byte order: Little-endian');
    WriteLine('|31| Chanels: Mono');
    WriteLine('|31| Set MSX filename to ['+GetMSXFileName(RAWFile)+']');
    WriteLine('|31| In PK8020/PK8010 KORVET you can read this file:');
    WriteLine('|31| LOAD "CAS:'+GetMSXFileName(RAWFile)+'"');
  End;

  _TheFile:=New(PBufStream, Init(TheFile, stOpenRead, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TheFile);
    Dispose(_TheFile, Done);
    Exit;
  End;

  Fz:=_TheFile^.GetSize;
  If Fz = 0 Then
  Begin
    InfoWindow^.WriteLine('|31| File: '+TheFile+' is empty');
    Dispose(_TheFile, Done);
    Exit;
  End;

  _RAWFile:=New(PBufStream, Init(RAWFile, stCreate, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + RAWFile);
    Dispose(_RAWFile, Done);
    Dispose(_TheFile, Done);
    Exit;
  End;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Convert BASIC file');

  DataLen:=0;
  If WriteWav Then
    _RawFile^.Seek(SizeOf(TWaveHeader) + SizeOf(TFmtHeader) + SizeOf(TDataHeader));

  For W:=1 to $1E00 do Write_bit_1;
  For W:=1 to 10 Do Write_Byte($D3);
  WriteFileName(GetMSXFileName(RAWFile));
  For W:=1 to $FFFF do
     _RAWFile^.Write(Nul0,SizeOf(Nul0));
  DataLen:=DataLen + $FFFF * SizeOf(Nul0);
  For W:=1 to $780 do Write_bit_1;
  repeat
     _TheFile^.Read(B,SizeOf(B));
     _FilePos:=_TheFile^.GetPos;
     GV1^.Update((100*_FilePos) Div Fz);
     If (_FilePos = 1) and (B = $FF) Then
       Continue;
     Write_Byte(B);
  until (_TheFile^.GetPos = Fz) or (_TheFile^.Status <> stOk);
  For W:=1 to 10 do Write_Byte($00);
  If WriteWav Then
    WriteWaveHeader;
  Dispose(_TheFile, Done);
  Dispose(_RAWFile, Done);
  Dispose(D,Done);
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Sucessfully!!!');
  End;
End;

Procedure Bin2Msx(TheFile:String; WriteWav:Boolean);
Var
   B:Byte;
   W:Word;
{   j:Byte;}
Const
   nul0:Integer=0;
begin
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Reading file '+TheFile);
    If WriteWav Then
      RAWFile:=Service.ChangeFileExt(TheFile,'WAV')
    Else
      RAWFile:=Service.ChangeFileExt(TheFile,'RAW');
    WriteLine('|31| Convert source to MSX tape binary file '+RAWFile);
    WriteLine('|31| Open this file in your Wave Editor or Player with following params:');
    WriteLine('|31| Sample rate: 44100 Hz');
    WriteLine('|31| Sample type: 16 Bit PCM');
    WriteLine('|31| Signed');
    WriteLine('|31| Byte order: Little-endian');
    WriteLine('|31| Chanels: Mono');
    WriteLine('|31| Set MSX filename to ['+GetMSXFileName(RAWFile)+']');
    WriteLine('|31| In PK8020/PK8010 KORVET you can read this file:');
    WriteLine('|31| LOAD "CAS:'+GetMSXFileName(RAWFile)+'",B[,R]');
    WriteLine('|31| Set load&run addres to 0x' + IntToHex(_LoadAddr, 4) + ' & 0x' + IntToHex(_StartAddr, 4));
  End;

  _TheFile:=New(PBufStream, Init(TheFile, stOpenRead, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Error open file ' + TheFile);
    Dispose(_TheFile, Done);
    Exit;
  End;

  Fz:=_TheFile^.GetSize;
  If Fz = 0 Then
  Begin
    InfoWindow^.WriteLine('|31| File: '+TheFile+' is empty');
    Dispose(_TheFile, Done);
    Exit;
  End;

  _RAWFile:=New(PBufStream, Init(RAWFile, stCreate, 2048));

  If _TheFile^.Status <> stOk Then
  Begin
    InfoWindow^.WriteLine('|31| Can''t create file ' + RAWFile);
    Dispose(_RAWFile, Done);
    Dispose(_TheFile, Done);
    Exit;
  End;

  New(D, Init(GV1, ''));
  Desktop^.Insert(D);
  D^.SetCurrentText('Convert binary file');

  DataLen:=0;
  If WriteWav Then
    _RawFile^.Seek(SizeOf(TWaveHeader) + SizeOf(TFmtHeader) + SizeOf(TDataHeader));

  For W:=1 to $1E00 do Write_bit_1;
  For W:=1 to 10 Do Write_Byte($D0);
  WriteFileName(GetMSXFileName(RAWFile));
  For W:=1 to $FFFF do
     _RAWFile^.Write(Nul0,SizeOf(Nul0));
  DataLen:=DataLen + $FFFF * SizeOf(Nul0);
  For W:=1 to $780 do Write_bit_1;

  _EndAddr:=Fz+_LoadAddr-1;
  _StartAddr:=_LoadAddr;
  Write_Byte(Lo(_LoadAddr));
  Write_Byte(Hi(_LoadAddr));
  Write_Byte(Lo(_EndAddr));
  Write_Byte(Hi(_EndAddr));
  Write_Byte(Lo(_StartAddr));
  Write_Byte(Hi(_StartAddr));
  repeat
     _TheFile^.Read(B,SizeOf(B));
     GV1^.Update((100*_TheFile^.GetPos) Div Fz);
     Write_Byte(B);
  until (_TheFile^.GetPos = Fz) or (_TheFile^.Status <> stOk);
  If WriteWav Then
    WriteWaveHeader;
  Dispose(_TheFile, Done);
  Dispose(_RAWFile, Done);
  Dispose(D,Done);
  With InfoWindow^ Do
  Begin
    WriteLine('|31| Sucessfully!!!');
  End;
End;

Var
  FileDialog: PFileDialog;
Const
  fdOptions: Word = fdOkButton + fdOpenButton;
  TXTFILEEXT = '.TXT.BAS.PAS.DOC';
  CASFILEEXT = '.CAS';
  BINFILEEXT = '.BIN';
  COMFILEEXT = '.COM';
Begin
  TheFile := '*.*';
  FileDialog := New(PFileDialog, Init(TheFile, 'Open file', '~F~ile name',
    fdOptions, 1));
  If ExecuteDialog(FileDialog, @TheFile) <> cmCancel Then
  Begin
    If InfoWindow <> Nil Then Dispose(InfoWindow, Done);
    InfoWindow := New(PInfoWindow , Init(TheFile));
    InsertWindow(InfoWindow);
    TheFile:=strupr(TheFile);
    If Pos(GetFileExt(TheFile),TXTFILEEXT)<>0 Then
    Begin
      Txt2Msx(TheFile, _WriteWav);
      Exit;
    End;
    If Pos(GetFileExt(TheFile),CASFILEEXT)<>0 Then
    Begin
      Cas2Msx(TheFile, _WriteWav);
      Exit;
    End;
    If Pos(GetFileExt(TheFile),BINFILEEXT)<>0 Then
    Begin
      Bin2Msx(TheFile, _WriteWav);
      Exit;
    End;
    If Pos(GetFileExt(TheFile),COMFILEEXT)<>0 Then
    Begin
      MessageBox(#3'Sorry, in this moment present only bin file conversion', nil, mfOKButton);
      Bin2Msx(TheFile, _WriteWav);
      Exit;
    End;
  End;
End;

Procedure TKorvetAPP.SetOptions;
Var
  optDialog:POptDialog;
  optData:TOptData;
Begin

  optDialog:=New(POptDialog, Init);

  optData._LoadAddr:='0x'+IntToHex(_LoadAddr, 4);
  optData._StartAddr:='0x'+IntToHex(_StartAddr, 4);
  optData._WriteWav:=_WriteWav;

  optDialog^.SetData(optData);

  if (deskTop^.execView( optDialog ) <> cmCancel) Then
  Begin
    optDialog^.GetData(optData);
    _LoadAddr:=StrToInt(optData._LoadAddr);
    _StartAddr:=StrToInt(optData._StartAddr);
    _WriteWav:=optData._WriteWav;
  End;

End;

Constructor TKorvetAPP.Init;
begin
  DisableCommands([cmRAWProcess,
                   cmTX1Process,
                   cmTX2Process,
                   cmCASProcess,
                   cmBASProcess,
                   cmSave,
                   cmSaveAs,
                   cmSaveAll
                   ]);
  inherited Init;
  _LoadAddr  :=$9000;
  _StartAddr := _LoadAddr;
  _WriteWav:=False;
end;
Var KorvetAPP:TKorvetAPP;
Begin
  KorvetAPP.Init;
  KorvetAPP.Run;
  KorvetAPP.Done;
End.
